package cn.iocoder.yudao.module.system.service.extra;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.system.controller.admin.extra.vo.PowerOfAttorneyPageReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.extra.ElderlyExtraPowerOfAttorneyDO;
import cn.iocoder.yudao.module.system.dal.mysql.extra.ElderlyExtraPowerOfAttorneyMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.system.enums.ErrorCodeConstants.ELDERLY_EXTRA_POWER_OF_ATTORNEY_NOT_EXISTS;

/**
 * (附件)授权委托书 Service 实现
 *
 * @author 管理员
 */
@Service
@Slf4j
public class ElderlyExtraPowerOfAttorneyServiceImpl implements ElderlyExtraPowerOfAttorneyService {

    @Resource
    private ElderlyExtraPowerOfAttorneyMapper mapper;

    @Override
    public Long create(ElderlyExtraPowerOfAttorneyDO createReqVO) {
        mapper.insert(createReqVO);
        return createReqVO.getId();
    }

    @Override
    public void update(ElderlyExtraPowerOfAttorneyDO updateReqVO) {
        validateExists(updateReqVO.getId());
        mapper.updateById(updateReqVO);
    }

    @Override
    public void delete(Long id) {
        validateExists(id);
        mapper.deleteById(id);
    }

    @Override
    public PageResult<ElderlyExtraPowerOfAttorneyDO> findPage(PowerOfAttorneyPageReqVO reqVO) {
        return mapper.selectPage(reqVO);
    }

    @Override
    public ElderlyExtraPowerOfAttorneyDO getDetail(Long id) {
        return validateExists(id);
    }

    @Override
    public List<ElderlyExtraPowerOfAttorneyDO> getListByElderId(Long elderId) {
        return mapper.selectList(
                new LambdaQueryWrapperX<ElderlyExtraPowerOfAttorneyDO>()
                        .eqIfPresent(ElderlyExtraPowerOfAttorneyDO::getElderId, elderId)
                        .orderByDesc(ElderlyExtraPowerOfAttorneyDO::getCreateTime)
        );
    }

    private ElderlyExtraPowerOfAttorneyDO validateExists(Long id) {
        ElderlyExtraPowerOfAttorneyDO record = mapper.selectById(id);
        if (record == null) {
            throw exception(ELDERLY_EXTRA_POWER_OF_ATTORNEY_NOT_EXISTS);
        }
        return record;
    }

}
